PROGRAM=exercise_09_09
CXX=g++
CXXFLAGS=-Wall -Wextra -Werror -std=c++03 -I. -g3

SOURCES:=main.cpp $(wildcard sources/*.cpp)
TEST_INPUTS:=(wildcard tests/test*.input)
PREPROCS:=$(patsubst %.cpp, builds/debug/%.ii, $(SOURCES))
ASSEMBLES:=$(patsubst %.cpp, builds/debug/%.s, $(SOURCES))
OBJS:=$(patsubst %.cpp, builds/debug/%.o, $(SOURCES))
TESTS:=$(patsubst %.input, builds/debug/%, &(TEST_INPUTS))

init: make_dir test1 builds/debug/$(PROGRAM)

test1: builds/debug/$(PROGRAM)
	./builds/debug/$(PROGRAM) > $@.output || echo "Negative test"
	diff $@.output tests/$@.expected && echo PASSED || echo FAILED

builds/debug/$(PROGRAM): $(OBJS) | .gitignore
	$(CXX)    $(CXXFLAGS) $^ -o $@

builds/debug/%.ii: %.cpp
	$(CXX) -E $(CXXFLAGS) $< -o $@

%.s: %.ii
	$(CXX) -S $(CXXFLAGS) $< -o $@

%.o: %.s
	$(CXX) -c $(CXXFLAGS) $< -o $@

make_dir:
	mkdir -p builds/debug/sources	

.gitignore:
	echo $(PROGRAM) > .gitignore
	
clean:
	rm -r -f builds .gitignore *.output
	
.PRECIOUS: $(PREPROCS) $(ASSEBLES)
.SECONDARY: $(PREPROCS) $(ASSEBLES)

